<?php
#############################################################################################
# @Name : ./core/import_asset.php
# @Description : import asset from a csv file
# @Call : /admin/parameters.php
# @Parameters : filename $_FILE[asset_import][name] or server key for command line execution
# @Author : Flox
# @Create : 20/01/2017
# @Update : 16/05/2017
# @Version : 3.1.21
#############################################################################################

//initialize variables 
if(!isset($_GET['server_key'])) $_GET['server_key'] = '';
if(!isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) $_SERVER['HTTP_ACCEPT_LANGUAGE']=0;
if(!isset($argv[0])) $argv[0] = '';
if(!isset($argv[1])) $argv[1] = '';
if(!isset($rparameters['debug'])) $rparameters['debug'] = '';
if(!isset($file_rename)) $file_rename='';
if(!isset($error)) $error='';

if ($rparameters['debug']==1) {echo "<u><b>DEBUG:</b></u><br />";}

//check if file is launch from command line 
if(!$file_rename)
{
	//database connection
	require_once(__DIR__."/../connect.php");

	//switch SQL mode to allow empty values in queries
	$db->exec('SET sql_mode = ""');

	//load parameters table
	$query=$db->query("SELECT * FROM tparameters");
	$rparameters=$query->fetch();
	$query->closeCursor();

	//locales
	$lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
	if ($lang=='fr') {$_GET['lang'] = 'fr_FR';}
	else {$_GET['lang'] = 'en_US';}
	define('PROJECT_DIR', realpath('../'));
	define('LOCALE_DIR', PROJECT_DIR .'/locale');
	define('DEFAULT_LOCALE', '($_GET[lang]');
	require_once(__DIR__.'/../components/php-gettext/gettext.inc');
	$encoding = 'UTF-8';
	$locale = (isset($_GET['lang']))? $_GET['lang'] : DEFAULT_LOCALE;
	T_setlocale(LC_MESSAGES, $locale);
	T_bindtextdomain($_GET['lang'], LOCALE_DIR);
	T_bind_textdomain_codeset($_GET['lang'], $encoding);
	T_textdomain($_GET['lang']);

	//define PHP time zone for log entries
	date_default_timezone_set('Europe/Paris');

	//generate url for command line execution
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN'){
		$logfileurl=__DIR__.'\..\log\asset_auto_import.log';
		$import_dir=__DIR__.'\..\upload\asset';
	} else {
		$logfileurl=__DIR__.'/../log/asset_auto_import.log';
		$import_dir=__DIR__.'/../upload/asset';
	}

	//create log file if not exist
	if (!file_exists($logfileurl)) {file_put_contents($logfileurl, "");} 
	
	//display head information for log and command line
	echo '--------------------------------------------------------------------'.PHP_EOL;
	echo '--------------------------ASSET AUTO IMPORT-------------------------'.PHP_EOL;
	echo '--------------------------------------------------------------------'.PHP_EOL;
	$logfile = file_get_contents($logfileurl); $logfile .= "-------------------------------------------------------------------- \n"; file_put_contents($logfileurl, $logfile);
	$logfile = file_get_contents($logfileurl); $logfile .= "---------------------------ASSET AUTO IMPORT------------------------ \n"; file_put_contents($logfileurl, $logfile);
	$logfile = file_get_contents($logfileurl); $logfile .= "-------------------------------------------------------------------- \n"; file_put_contents($logfileurl, $logfile);
	echo PHP_EOL;
} else {
	$import_dir='./upload/asset';
}

if(($argv[1]==$rparameters['server_private_key']) || $file_rename)
{
	
	if($argv[1])
	{
		//server key verification
		echo 'Server key validation: OK'.PHP_EOL;
		$logfile = file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "Server key validation: OK \n"; file_put_contents($logfileurl, $logfile);
		
		//OS verification
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
		{ 
			echo 'OS Windows: OK'.PHP_EOL;
			$logfile = file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "OS: Windows detected \n"; file_put_contents($logfileurl, $logfile);
		} else {
			echo 'OS Linux: OK'.PHP_EOL;
			$logfile = file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "OS: Linux detected \n"; file_put_contents($logfileurl, $logfile);
		}
		//directory verification, if scandir not exist create it
		if(!is_dir($import_dir)){mkdir($import_dir, 0777);} 
	}
	
	//get file to import
	if($file_rename){$filename = $file_rename;}
	elseif($argv[1]){$filename = array_diff(scandir($import_dir), array('..', '.')); if($filename) {$filename=$filename[2];}}
	
	//check if is filename var exist 
	if($filename)
	{
		//check if file exist
		if(file_exists("$import_dir/$filename") || $argv[1]) 
		{
			//check csv file
			$extension=explode('.',$filename);
			$extension=strtolower(end($extension));
			if($extension=='csv')
			{
				//read file
				$file = fopen($import_dir.'/'.$filename, 'r');
				$i=0;
				while (($line = fgetcsv($file)) !== FALSE) 
				{
					//init var
					$new_asset=0;
					
					//detect title first line to exclude
					$line[0]=utf8_encode($line[0]);
					$read_line=explode(";",$line[0]);
					
					if($read_line[0]!="Numéro de l'équipement") //don't show first line if title line is detected
					{
						//increment counter
						$i++;
						//explode line date to keep array values
						$read_line=explode(";",$line[0]);
						//put data to var and secure data
						$sn_internal=strip_tags($db->quote($read_line[0]));
						$netbios=strip_tags($db->quote($read_line[1]));
						$sn_manufacturer=strip_tags($db->quote($read_line[2]));
						$sn_indent=strip_tags($db->quote($read_line[3]));
						$ip=strip_tags($db->quote($read_line[4]));
						$mac=strip_tags($db->quote($read_line[5]));
						$description=strip_tags($db->quote($read_line[6]));
						$type=strip_tags($db->quote($read_line[7]));
						$manufacturer=strip_tags($db->quote($read_line[8]));
						$model=strip_tags($db->quote($read_line[9]));
						$user=strip_tags($read_line[10]);
						$state=strip_tags($db->quote($read_line[11]));
						$department=strip_tags($db->quote($read_line[12]));
						$location=strip_tags($db->quote($read_line[13]));
						$date_install=$read_line[14];
						$date_end_warranty=$read_line[15];
						$date_stock=$read_line[16];
						$date_standbye=$read_line[17];
						$date_recycle=$read_line[18];
						$date_last_ping=$read_line[19];
						$socket=strip_tags($db->quote($read_line[20]));
						$technician=strip_tags($read_line[21]);
						$maintenance=strip_tags($db->quote($read_line[22]));
						
						//convert date to SQL format
						$date_install = DateTime::createFromFormat('d/m/Y', $date_install);
						if($date_install){$date_install=$date_install->format('Y-m-d');}
						$date_end_warranty = DateTime::createFromFormat('d/m/Y', $date_end_warranty);
						if($date_end_warranty){$date_end_warranty=$date_end_warranty->format('Y-m-d');}
						$date_stock = DateTime::createFromFormat('d/m/Y', $date_stock);
						if($date_stock){$date_stock=$date_stock->format('Y-m-d');}
						$date_standbye = DateTime::createFromFormat('d/m/Y', $date_standbye);
						if($date_standbye){$date_standbye=$date_standbye->format('Y-m-d');}
						$date_recycle = DateTime::createFromFormat('d/m/Y', $date_recycle);
						if($date_recycle){$date_recycle=$date_recycle->format('Y-m-d');}
						$date_last_ping = DateTime::createFromFormat('d/m/Y', $date_last_ping);
						if($date_last_ping){$date_last_ping=$date_last_ping->format('Y-m-d');}
						
						//check if asset already exist in GS db, compare with MAC address, and update all fields
						if($mac)
						{
							//convert in lowercase to compare
							$csv_mac=strtolower($mac);
							
							$query=$db->query("SELECT * FROM tassets_iface WHERE mac=$csv_mac AND disable='0'");
							$row=$query->fetch();
							$query->closeCursor();
							if($row['mac']!='')
							{
								$gs_mac_disp=str_replace("'", "",$row['mac']);
								$gs_mac_disp=strtoupper($gs_mac_disp);
								$msg="[$gs_mac_disp] Asset already exist in GestSup database, check for update:";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								
								//load asset fiels from GS DB
								$query2=$db->query("SELECT * FROM tassets WHERE id=(SELECT MAX(asset_id) FROM tassets_iface WHERE mac='$row[mac]' AND disable='0') AND disable='0'");
								$gs=$query2->fetch();
								$query2->closeCursor();
								//compare sn_internal
								$gs['sn_internal']=$db->quote($gs['sn_internal']);
								if($gs['sn_internal']!=$sn_internal && $sn_internal!='\'\'') {
									$msg="[$gs_mac_disp] -Update sn_internal for asset_id $gs[id] with sn_internal $sn_internal";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET sn_internal=$sn_internal WHERE id='$gs[id]'");
								}
								//compare netbios
								$gs['netbios']=$db->quote($gs['netbios']);
								if($gs['netbios']!=$netbios && $netbios!='\'\'') {
									$msg="[$gs_mac_disp] -update name for asset_id $gs[id] with name $netbios";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET netbios=$netbios WHERE id='$gs[id]'");
								}
								//compare sn_manufacturer
								$gs['sn_manufacturer']=$db->quote($gs['sn_manufacturer']);
								if($gs['sn_manufacturer']!=$sn_manufacturer && $sn_manufacturer!='\'\'') {
									$msg="[$gs_mac_disp] -update sn_manufacturer for asset_id $gs[id] with name $sn_manufacturer";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET sn_manufacturer=$sn_manufacturer WHERE id='$gs[id]'");
								}
								//compare sn_indent
								$gs['sn_indent']=$db->quote($gs['sn_indent']);
								if($gs['sn_indent']!=$sn_indent && $sn_indent!='\'\'') {
									$msg="[$gs_mac_disp]  -update sn_indent for asset_id $gs[id] with name $sn_indent";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET sn_indent=$sn_indent WHERE id='$gs[id]'");
								}
								//compare description
								$gs['description']=$db->quote($gs['description']);
								if($gs['description']!=$description && $description!='\'\'') {
									$msg="[$gs_mac_disp] -update description for asset_id $gs[id] with name $description";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET description=$description WHERE id='$gs[id]'");
								}
								//date installation
								if($gs['date_install']!=$date_install && $date_install!='') {
									$msg="[$gs_mac_disp] -update date_install for asset_id $gs[id] with date_install $date_install";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET date_install='$date_install' WHERE id='$gs[id]'");
								}
								//date end warranty
								if($gs['date_end_warranty']!=$date_end_warranty && $date_end_warranty!='') {
									$msg="[$gs_mac_disp] -update date_end_warranty for asset_id $gs[id] with date_end_warranty $date_end_warranty";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET date_end_warranty='$date_end_warranty' WHERE id='$gs[id]'");
								}
								//date stock
								if($gs['date_stock']!=$date_stock && $date_stock!='') {
									$msg="[$gs_mac_disp] -update date_stock for asset_id $gs[id] with date_stock $date_stock";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET date_stock='$date_stock' WHERE id='$gs[id]'");
								}
								//date standby
								if($gs['date_standbye']!=$date_standbye && $date_standbye!='') {
									$msg="[$gs_mac_disp] -update date_standbye for asset_id $gs[id] with date_standbye $date_standbye";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET date_standbye='$date_standbye' WHERE id='$gs[id]'");
								}
								//date recycle
								if($gs['date_recycle']!=$date_recycle && $date_recycle!='') {
									$msg="[$gs_mac_disp] -update date_recycle for asset_id $gs[id] with date_recycle $date_recycle";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET date_recycle='$date_recycle' WHERE id='$gs[id]'");
								}
								//date last ping
								if($gs['date_last_ping']!=$date_last_ping && $date_last_ping!='') {
									$msg="[$gs_mac_disp] -update date_last_ping for asset_id $gs[id] with date_last_ping $date_last_ping";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET date_last_ping='$date_last_ping' WHERE id='$gs[id]'");
								}
								//socket
								$gs['socket']=$db->quote($gs['socket']);
								if($gs['socket']!=$socket && $socket!='\'\'') {
									$msg="[$gs_mac_disp] -update socket for asset_id $gs[id] with name $socket";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets SET socket=$socket WHERE id='$gs[id]'");
								}
								//ip address
								$row['ip']=$db->quote($row['ip']);
								if($row['ip']!=$ip && $ip!='\'\'') {
									$msg="[$gs_mac_disp] -update IP for asset_id $gs[id] with ip $ip";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets_iface SET ip=$ip WHERE id='$row[id]'");
								}
								//ip address
								$row['netbios']=$db->quote($row['netbios']);
								if($row['netbios']!=$netbios && $netbios!='\'\'') {
									$msg="[$gs_mac_disp] -update netbios for asset_id $gs[id] with netbios $netbios";
									if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
									else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
									$db->exec("UPDATE tassets_iface SET netbios=$netbios WHERE id='$row[id]'");
								}
								//type
								if($type!='\'\'') {
									//check if type already exist
									$query2=$db->query("SELECT name FROM tassets_type WHERE name=$type");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new type asset_id $gs[id] with type $type";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tassets_type (name) VALUES ($type)");
									}
									//check if asset have different type between CSV and GS DB
									$query2=$db->query("SELECT tassets_type.name,tassets_type.id FROM tassets_type,tassets WHERE tassets_type.id=tassets.type AND tassets.id='$gs[id]'");
									$row2_type=$query2->fetch();
									$query2->closeCursor();
									$row2_type['name']=$db->quote($row2_type['name']);
									if($row2_type['name']!=$type)
									{
										//find new type id
										$query2=$db->query("SELECT id FROM tassets_type WHERE name=$type");
										$row2_type=$query2->fetch();
										$query2->closeCursor();
										$msg="[$gs_mac_disp] -update type asset_id $gs[id] with type $type";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET type='$row2_type[id]' WHERE id='$gs[id]'");
									}
								}
								//manufacturer
								if($manufacturer!='\'\'') {
									//check if manufacturer already exist
									$query2=$db->query("SELECT name FROM tassets_manufacturer WHERE name=$manufacturer");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new manufacturer asset_id $gs[id] with manufacturer $manufacturer";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tassets_manufacturer (name) VALUES ($manufacturer)");
									}
									//check if asset have different type between CSV and GS DB
									$query2=$db->query("SELECT tassets_manufacturer.name,tassets_manufacturer.id FROM tassets_manufacturer,tassets WHERE tassets_manufacturer.id=tassets.manufacturer AND tassets.id='$gs[id]' ");
									$row2_manufacturer=$query2->fetch();
									$query2->closeCursor();
									$row2_manufacturer['name']=$db->quote($row2_manufacturer['name']);
									if($row2_manufacturer['name']!=$manufacturer)
									{
										//find new type id
										$query2=$db->query("SELECT id FROM tassets_manufacturer WHERE name=$manufacturer");
										$row2_manufacturer=$query2->fetch();
										$query2->closeCursor();
										$msg="[$gs_mac_disp] -update manufacturer for asset_id $gs[id] with manufacturer $manufacturer";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET manufacturer='$row2_manufacturer[id]' WHERE id='$gs[id]'");
									}
								}
								//model
								if($model!='\'\'') {
									//check if model already exist
									$query2=$db->query("SELECT name FROM tassets_model WHERE name=$model");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new model asset_id $gs[id] with model $model";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tassets_model (name,type,manufacturer,ip) VALUES ($model,'$row2_type[id]','$row2_manufacturer[id]','1')");
									}
									//check if asset have different model between CSV and GS DB
									$query2=$db->query("SELECT tassets_model.name FROM tassets_model,tassets WHERE tassets_model.id=tassets.model AND tassets.id='$gs[id]' ");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$row2['name']=$db->quote($row2['name']);
									if($row2['name']!=$model)
									{
										//find new type id
										$query3=$db->query("SELECT id FROM tassets_model WHERE name=$model");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update model for asset_id $gs[id] with model $model";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET model='$row3[id]' WHERE id='$gs[id]'");
									}
								}
								//user
								if($user!='') {
									$user_array=explode(" ",$user);
									$csv_firstname=$user_array[0];
									$csv_lastname=$user_array[1];
									$csv_firstname=$db->quote($csv_firstname);
									$csv_lastname=$db->quote($csv_lastname);
									//check if user already exist and create it if not exist
									$query2=$db->query("SELECT id FROM tusers WHERE firstname LIKE $csv_firstname AND lastname LIKE $csv_lastname ");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new user $csv_firstname $csv_lastname";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tusers (firstname,lastname,profile) VALUES ($csv_firstname,$csv_lastname,'2')");
									}
									//check if asset have different user between CSV and GS DB
									$query2=$db->query("SELECT tusers.id,tusers.firstname,tusers.lastname FROM tusers WHERE id=(SELECT user FROM tassets WHERE id='$gs[id]')");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$gs_firstname=strtolower($row2['firstname']); 
									$gs_lastname=strtolower($row2['lastname']); 
									$gs_firstname=$db->quote($gs_firstname);
									$gs_lastname=$db->quote($gs_lastname);
									$csv_firstname = strtolower($csv_firstname);
									$csv_lastname = strtolower($csv_lastname);
									if(($gs_firstname!=$csv_firstname) || ($gs_lastname!=$csv_lastname) )
									{
										//find new user id to associate with asset
										$query3=$db->query("SELECT id FROM tusers WHERE firstname LIKE $csv_firstname AND lastname LIKE $csv_lastname AND disable='0'");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update user for asset_id $gs[id] with user_id=$row3[0] $user_array[0] $user_array[1]";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET user='$row3[id]' WHERE id='$gs[id]'");
									}
									
								}
								//technician
								if($technician!='') {
									$technician_array=explode(" ",$technician);
									$csv_firstname=$technician_array[0];
									$csv_lastname=$technician_array[1];
									$csv_firstname=$db->quote($csv_firstname);
									$csv_lastname=$db->quote($csv_lastname);
									//check if technician already exist and create it if not exist
									$query2=$db->query("SELECT id FROM tusers WHERE firstname LIKE $csv_firstname AND lastname LIKE $csv_lastname ");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new technician $csv_firstname $csv_lastname";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tusers (firstname,lastname,profile) VALUES ($csv_firstname,$csv_lastname,'0')");
									}
									//check if asset have different technician between CSV and GS DB
									$query2=$db->query("SELECT tusers.id,tusers.firstname,tusers.lastname FROM tusers WHERE id=(SELECT technician FROM tassets WHERE id='$gs[id]')");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$gs_firstname=strtolower($row2['firstname']); 
									$gs_lastname=strtolower($row2['lastname']); 
									$gs_firstname=$db->quote($gs_firstname);
									$gs_lastname=$db->quote($gs_lastname);
									$csv_firstname = strtolower($csv_firstname);
									$csv_lastname = strtolower($csv_lastname);
									if(($gs_firstname!=$csv_firstname) || ($gs_lastname!=$csv_lastname) )
									{
										//find new technician id to associate with asset
										$query3=$db->query("SELECT id FROM tusers WHERE firstname LIKE $csv_firstname AND lastname LIKE $csv_lastname AND disable='0'");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update technician for asset_id $gs[id] with user_id=$row3[0] $technician_array[0] $technician_array[1]";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET technician='$row3[id]' WHERE id='$gs[id]'");
									}
								}
								//state
								if($state!='\'\'') {
									//check if state already exist and create it if not exist
									$query2=$db->query("SELECT id FROM tassets_state WHERE name=$state");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new state $state";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tassets_state (name) VALUES ($state)");
									}
									//check if asset have different state between CSV and GS DB
									$query2=$db->query("SELECT name FROM tassets_state WHERE id=(SELECT state FROM tassets WHERE id='$gs[id]')");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$row2['name']=$db->quote($row2['name']);
									if(($row2['name']!=$state))
									{
										//find new state id to associate with asset
										$query3=$db->query("SELECT id FROM tassets_state WHERE name=$state AND disable='0'");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update state for asset_id $gs[id] with state $state";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET state='$row3[id]' WHERE id='$gs[id]'");
									}
								}
								//department
								if($department!='\'\'') {
									//check if service already exist and create it if not exist
									$query2=$db->query("SELECT id FROM tservices WHERE name=$department");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new service $department";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tservices (name) VALUES ($department)");
									}
									//check if asset have different service between CSV and GS DB
									$query2=$db->query("SELECT name FROM tservices WHERE id=(SELECT department FROM tassets WHERE id='$gs[id]')");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$row2['name']=$db->quote($row2['name']);
									if(($row2['name']!=$department))
									{
										//find new state id to associate with asset
										$query3=$db->query("SELECT id FROM tservices WHERE name=$department AND disable='0'");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update service for asset_id $gs[id] with service $department";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET department='$row3[id]' WHERE id='$gs[id]'");
									}
								}
								//maintenance
								if($maintenance!='\'\'') {
									//check if maintenance service already exist and create it if not exist
									$query2=$db->query("SELECT id FROM tservices WHERE name=$maintenance");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new maintenance service $maintenance";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tservices (name) VALUES ($maintenance)");
									}
									//check if asset have different service between CSV and GS DB
									$query2=$db->query("SELECT name FROM tservices WHERE id=(SELECT maintenance FROM tassets WHERE id='$gs[id]')");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$row2['name']=$db->quote($row2['name']);
									if(($row2['name']!=$maintenance))
									{
										//find new state id to associate with asset
										$query3=$db->query("SELECT id FROM tservices WHERE name=$maintenance AND disable='0'");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update maintenance service for asset_id $gs[id] with maintenance service $maintenance";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET maintenance='$row3[id]' WHERE id='$gs[id]'");
									}
								}
								//location
								if($location!='\'\'') {
									//check if location already exist and create it if not exist
									$query2=$db->query("SELECT id FROM tassets_location WHERE name=$location AND disable='0'");
									$row2=$query2->fetch();
									$query2->closeCursor();
									if(!$row2) {
										$msg="[$gs_mac_disp] -insert new location -$location-";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("INSERT INTO tassets_location (name) VALUES ($location)");
									}
									//check if asset have different service between CSV and GS DB
									$query2=$db->query("SELECT name FROM tassets_location WHERE id=(SELECT location FROM tassets WHERE id='$gs[id]')");
									$row2=$query2->fetch();
									$query2->closeCursor();
									$row2['name']=$db->quote($row2['name']);
									if(($row2['name']!=$location))
									{
										//find new state id to associate with asset
										$query3=$db->query("SELECT id FROM tassets_location WHERE name=$location AND disable='0'");
										$row3=$query3->fetch();
										$query3->closeCursor();
										$msg="[$gs_mac_disp] -update location for asset_id $gs[id] with location $location";
										if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
										else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
										$db->exec("UPDATE tassets SET location='$row3[id]' WHERE id='$gs[id]'");
									}
								}
								//update discover flag
								$db->exec("UPDATE tassets SET discover_import_csv='1' WHERE id='$gs[id]'");
							} else {
								$csv_mac_disp=str_replace("'", "",$csv_mac);
								$csv_mac_disp=strtoupper($csv_mac_disp);
								$msg="[$csv_mac_disp] Asset not exist in GestSup database, create new asset:";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$new_asset=1;
							}
						} 
						if ($new_asset==1 || !$mac) //create new asset if no MAC adresse is present in CSV file or if asset not exist in GestSup DB
						{
							//get id value or create row in specific tables
							//type
							$find_type=0;
							$query = $db->query("SELECT id,name FROM `tassets_type`");
							while ($row=$query->fetch()){if ($type=="'$row[name]'") $find_type=$row['id'];}
							if($find_type==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create type $type: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tassets_type` (`name`) VALUES ($type)");
								$type=$db->lastInsertId();
							} else {$type=$find_type;}
							//manufacturer
							$find_manufacturer=0;
							$query = $db->query("SELECT id,name FROM `tassets_manufacturer`");
							while ($row=$query->fetch()){if ($manufacturer=="'$row[name]'") $find_manufacturer=$row['id'];}
							if($find_manufacturer==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create manufacturer $manufacturer: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tassets_manufacturer` (`name`) VALUES ($manufacturer)");
								$manufacturer=$db->lastInsertId();
							} else {$manufacturer=$find_manufacturer;}
							//model
							$find_model=0;
							$query = $db->query("SELECT id,name FROM `tassets_model`");
							while ($row=$query->fetch()){if ($model=="'$row[name]'") $find_model=$row['id'];}
							if($find_model==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create model $model: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tassets_model` (`name`,`manufacturer`,`type`,`ip`) VALUES ($model,$manufacturer,$type,'1')");
								$model=$db->lastInsertId();
							} else {$model=$find_model;}
							//user
							$find_user=0;
							$csv_user=explode(" ", $user);
							if(!isset($csv_user[0])) $csv_user[0] = '';
							if(!isset($csv_user[1])) $csv_user[1] = '';
							$csv_firstname=$csv_user[0];
							$csv_lastname=$csv_user[1];
							$query = $db->query("SELECT id,firstname,lastname FROM `tusers` WHERE disable='0'");
							while ($row=$query->fetch()){if ($csv_firstname==$row['firstname'] && $csv_lastname==$row['lastname']) $find_user=$row['id'];}
							if($find_user==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create user $user: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$csv_firstname=$db->quote($csv_firstname);
								$csv_lastname=$db->quote($csv_lastname);
								$db->exec("INSERT INTO `tusers` (`firstname`,`lastname`,`profile`) VALUES ($csv_firstname,$csv_lastname,'2')");
								$user=$db->lastInsertId();
							} else {$user=$find_user;}
							//state
							$find_state=0;
							$query = $db->query("SELECT id,name FROM `tassets_state`");
							while ($row=$query->fetch()){if ($state=="'$row[name]'") $find_state=$row['id'];}
							if($find_state==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create state $state: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tassets_state` (`name`) VALUES ($state)");
								$state=$db->lastInsertId();
							} else {$state=$find_state;}
							//department
							$find_department=0;
							$query = $db->query("SELECT id,name FROM `tservices` WHERE disable='0'");
							while ($row=$query->fetch()){if ($department=="'$row[name]'") $find_department=$row['id'];}
							if($find_department==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create department $department: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tservices` (`name`) VALUES ($department)");
								$department=$db->lastInsertId();
							} else {$department=$find_department;}
							//location
							$find_location=0;
							$query = $db->query("SELECT id,name FROM `tassets_location` WHERE disable='0'");
							while ($row=$query->fetch()){if ($location=="'$row[name]'") $find_location=$row['id'];}
							if($find_location==0 && $location) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create location $location: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tassets_location` (`name`) VALUES ($location)");
								$location=$db->lastInsertId();
							} else {$location=$find_location;}
							//technician
							$find_technician=0;
							$csv_technician=explode(" ", $technician);
							if(!isset($csv_technician[0])) $csv_technician[0] = '';
							if(!isset($csv_technician[1])) $csv_technician[1] = '';
							$csv_firstname=$csv_technician[0];
							$csv_lastname=$csv_technician[1];
							$query = $db->query("SELECT id,firstname,lastname FROM `tusers` WHERE disable='0'");
							while ($row=$query->fetch()){if ($csv_firstname==$row['firstname'] && $csv_lastname==$row['lastname']) $find_technician=$row['id'];}
							if($find_technician==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create technician $technician: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$csv_firstname=$db->quote($csv_firstname);
								$csv_lastname=$db->quote($csv_lastname);
								$db->exec("INSERT INTO `tusers` (`firstname`,`lastname`,`profile`) VALUES ($csv_firstname,$csv_lastname, '0')");
								$technician=$db->lastInsertId();
							} else {$technician=$find_technician;}
							//maintenance
							$find_maintenance=0;
							$query = $db->query("SELECT id,name FROM `tservices` WHERE disable='0'");
							while ($row=$query->fetch()){if ($maintenance=="'$row[name]'") $find_maintenance=$row['id'];}
							if($find_maintenance==0) //create if not find in current table
							{
								$msg="[$csv_mac_disp] -create maintenance $maintenance: not found in GestSup database";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								$db->exec("INSERT INTO `tservices` (`name`) VALUES ($maintenance)");
								$maintenance=$db->lastInsertId();
							} else {$maintenance=$find_maintenance;}
							
							$query="INSERT INTO tassets 
							(sn_internal,netbios,sn_manufacturer,sn_indent,description,type,manufacturer,model,user,state,department,location,date_install,date_end_warranty,date_stock,date_standbye,date_recycle,date_last_ping,socket,technician,maintenance)
							VALUES
							($sn_internal, $netbios, $sn_manufacturer, $sn_indent, $description, $type, $manufacturer, $model, $user, $state, $department, $location, '$date_install', '$date_end_warranty', '$date_stock', '$date_standbye', '$date_recycle', '$date_last_ping', $socket, $technician, $maintenance)";
							if ($rparameters['debug']==1) {if(!$argv[0]){echo "$query";}}
							$db->exec("$query");
							$last_asset=$db->lastInsertId();
							
							//update discover flag
							$db->exec("UPDATE tassets SET discover_import_csv='1' WHERE id='$last_asset'");
							
							//iface
							if ($ip)
							{
								$msg="[$csv_mac_disp] -create iface with IP: $ip .";
								if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
								else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
								
								$db->exec("INSERT INTO `tassets_iface` (`role_id`,`asset_id`,`netbios`,`ip`,`mac`,`disable`) VALUES ('1',$last_asset, $netbios,$ip,$mac,'0')");
								$maintenance=$db->lastInsertId();
							}
						}
					}
				}
				fclose($file);
				//delete import file
				unlink("$import_dir/$filename");
				//display result
				if($i==0)
				{
					$msg="ERROR: file is empty";
					if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
					else {if ($rparameters['debug']==1) {echo "$msg<br />";}}
				} else {
					$msg="Total checked: $i assets";
					if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
					else {echo '<div class="alert alert-block alert-success"><center><i class="icon-ok green"></i> '.T_('Import de').' '.$i.' '.T_('équipements effectué avec succès.').' </center></div>';}
				}
			} else {
				$msg="File extension: KO (file must be in csv format $filename)";
				if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
				else {$error='<div class="alert alert-danger"><strong><i class="icon-remove"></i>'.T_('Erreur').':</strong> '.T_("L'extension du fichier d'import n'est pas supporté, importer un fichier de type CSV").'.<br></div>';}
			}
		} else {
			$msg="ERROR: Import file not exist";
			if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
			else {$error='<div class="alert alert-danger"><strong><i class="icon-remove"></i>'.T_('Erreur').':</strong> '.T_('Le fichier d\'import des équipements n\'existe pas').'.<br></div>';}
		}
		
	} else {
		$msg="No new file detected: OK";
		if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
	}
} else {
	$msg="Server key validation: KO Wrong server key please check in Administration > System your private server key";
	if($argv[0]){echo $msg.PHP_EOL;$logfile=file_get_contents($logfileurl); $logfile .= '['.date('Y-m-d H:i:s').'] '; $logfile .= "$msg \n"; file_put_contents($logfileurl, $logfile);}
}
?>